Bug 907075 - (qaccessibilityclient) Review Request: qaccessibilityclient - Accessibility client library for Qt
Review Request: qaccessibilityclient - Accessibility client library for Qt
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Kevin Kofler
Fedora Extras Quality Assurance
:
Depends On:
Blocks: kde-reviews simon kde-4.10
  Show dependency treegraph
 
Reported: 2013-02-02 22:43 EST by Rex Dieter
Modified: 2013-03-14 23:02 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-03-14 23:02:43 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
kevin: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Rex Dieter 2013-02-02 22:43:57 EST
Spec URL: http://rdieter.fedorapeople.org/rpms/simon/qaccessibilityclient.spec
SRPM URL: http://rdieter.fedorapeople.org/rpms/simon/qaccessibilityclient-0.1.0-0.1.20121113git.fc18.src.rpm
Description: QAccessibilityClient library is used when writing accessibility clients
Fedora Account System Username: rdieter1
Comment 1 Kevin Kofler 2013-02-02 23:10:32 EST
As in the other review, the Fedora Account System Username should be just rdieter, not rdieter1. :-)
Comment 2 Rex Dieter 2013-02-03 08:57:07 EST
right, of course.

Fedora Account System Username: rdieter


And, scratch build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=4924430
Comment 3 Kevin Kofler 2013-03-13 19:47:08 EDT
First step, a cursory glance at the specfile:

> # drop broken FindOpenCV.cmake
> rm -fv cmake/FindOpenCV.cmake

Huh? There's no such file to delete. (This is no blocker because rm -f of a non-existent file will just do nothing, but please remove that bogus rm.)

> Url:     https://…

Pedantic hairsplitting: Isn't the canonical spelling of this tag "URL:" rather than "Url:"? :-) (RPM is not case-sensitive in this place, so it doesn't really matter. So there too, no blocker.)
Comment 4 Kevin Kofler 2013-03-13 21:25:27 EDT
Review complete, some issues found:

Package Review
==============

Key:
[x] = Pass
[!] = Fail
[-] = Not applicable
[?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
  x No known patent problems
  x No emulator, no firmware, no binary-only or prebuilt components
[x]: %build honors applicable compiler flags or justifies otherwise.
  x %cmake macro used
[x]: Package contains no bundled libraries without FPC exception.
[!]: Changelog in prescribed format.
  ! see rpmlint output:
    qaccessibilityclient.i686: W: incoherent-version-in-changelog 0.1.0-1.20121113git ['0.1.0-0.1.20121113git.fc18', '0.1.0-0.1.20121113git']
    changelog says 0.1.0-1.20121113git, should say 0.1.0-0.1.20121113git
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
  - not a GUI application
[x]: Development files must be in a -devel package
[!]: Package requires other packages for directories it uses.
  ! -devel needs Requires: cmake for directory ownership
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[x]: Package complies to the Packaging Guidelines
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "LGPL", "Unknown or generated". 2 files have unknown license. Detailed
     output of licensecheck:
     > LGPL
     > ----
     > /var/lib/mock/fedora-18-i386/root/builddir/build/BUILD/qaccessibilityclient-0.1.0/tests/auto/simple/simplewidgetapp.cpp
     Checked to be LGPLv2 (2.1) or LGPLv3 (or later as approved by KDE e.V.) as the rest.
     > Unknown or generated
     > --------------------
     > /var/lib/mock/fedora-18-i386/root/builddir/build/BUILD/qaccessibilityclient-0.1.0/src/atspi/atspi-constants.h
     This one is generated, no reason to believe it is not covered by the same license, AT-SPI2 is LGPLv2+ (which is a superset of the qaccessibilityclient license).
[x]: License file installed when any subpackage combination is installed.
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: If the package is under multiple licenses, the licensing breakdown must
     be documented in the spec.
  x "# KDE e.V. may determine that future LGPL versions are accepted" documented
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[!]: Requires correct, justified where necessary.
  ! -devel is missing a Requires: qt4-devel (can't use it without that)
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[-]: Large documentation must go in a -doc subpackage.
     Note: Documentation size is 40960 bytes in 4 files.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Fully versioned dependency in subpackages, if present.
[x]: Spec file lacks Packager, Vendor, PreReq tags.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[-]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
  - git checkout (script to reproduce included)
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).

===== SHOULD items =====

Generic:
[!]: Spec use %global instead of %define.
     Note: %define snap 20121113git
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
  x no newer commits in upstream git
[x]: Package does not include license text files separate from upstream.
[x]: Scriptlets must be sane, if used.
[x]: SourceX tarball generation or download is documented.
     Note: Package contains tarball without URL, check comments
  x Source1: qaccessibilityclient_snapshot.sh
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
  x primary architectures: Koji scratch build in comment #2 passed
  ? secondary architectures not checked
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Uses parallel make.
[x]: SourceX is a working URL.

===== EXTRA items =====

Generic:
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[!]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
  ! rpmlint complains about:
qaccessibilityclient.i686: W: undefined-non-weak-symbol /usr/lib/libqaccessibilityclient.so.0.1.0 QAction::QAction(QObject*)
qaccessibilityclient.i686: W: undefined-non-weak-symbol /usr/lib/libqaccessibilityclient.so.0.1.0 QKeySequence::QKeySequence(QString const&)
qaccessibilityclient.i686: W: undefined-non-weak-symbol /usr/lib/libqaccessibilityclient.so.0.1.0 QAction::setText(QString const&)
qaccessibilityclient.i686: W: undefined-non-weak-symbol /usr/lib/libqaccessibilityclient.so.0.1.0 QAction::setShortcut(QKeySequence const&)
qaccessibilityclient.i686: W: undefined-non-weak-symbol /usr/lib/libqaccessibilityclient.so.0.1.0 QKeySequence::~QKeySequence()
qaccessibilityclient.i686: W: undefined-non-weak-symbol /usr/lib/libqaccessibilityclient.so.0.1.0 QAction::setWhatsThis(QString const&)
qaccessibilityclient.i686: W: undefined-non-weak-symbol /usr/lib/libqaccessibilityclient.so.0.1.0 QAction::setEnabled(bool)
    libqaccessibilityclient needs to link libQtGui.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: qaccessibilityclient-0.1.0-0.1.20121113git.fc18.i686.rpm
          qaccessibilityclient-devel-0.1.0-0.1.20121113git.fc18.i686.rpm
qaccessibilityclient.i686: W: name-repeated-in-summary C QAccessibilityClient
qaccessibilityclient.i686: W: incoherent-version-in-changelog 0.1.0-1.20121113git ['0.1.0-0.1.20121113git.fc18', '0.1.0-0.1.20121113git']
qaccessibilityclient.i686: W: no-manual-page-for-binary accessibleapps
qaccessibilityclient-devel.i686: W: no-documentation
2 packages and 0 specfiles checked; 0 errors, 4 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint qaccessibilityclient-devel qaccessibilityclient
qaccessibilityclient-devel.i686: W: no-documentation
qaccessibilityclient.i686: W: name-repeated-in-summary C QAccessibilityClient
qaccessibilityclient.i686: W: incoherent-version-in-changelog 0.1.0-1.20121113git ['0.1.0-0.1.20121113git.fc18', '0.1.0-0.1.20121113git']
qaccessibilityclient.i686: W: undefined-non-weak-symbol /usr/lib/libqaccessibilityclient.so.0.1.0 QAction::QAction(QObject*)
qaccessibilityclient.i686: W: undefined-non-weak-symbol /usr/lib/libqaccessibilityclient.so.0.1.0 QKeySequence::QKeySequence(QString const&)
qaccessibilityclient.i686: W: undefined-non-weak-symbol /usr/lib/libqaccessibilityclient.so.0.1.0 QAction::setText(QString const&)
qaccessibilityclient.i686: W: undefined-non-weak-symbol /usr/lib/libqaccessibilityclient.so.0.1.0 QAction::setShortcut(QKeySequence const&)
qaccessibilityclient.i686: W: undefined-non-weak-symbol /usr/lib/libqaccessibilityclient.so.0.1.0 QKeySequence::~QKeySequence()
qaccessibilityclient.i686: W: undefined-non-weak-symbol /usr/lib/libqaccessibilityclient.so.0.1.0 QAction::setWhatsThis(QString const&)
qaccessibilityclient.i686: W: undefined-non-weak-symbol /usr/lib/libqaccessibilityclient.so.0.1.0 QAction::setEnabled(bool)
qaccessibilityclient.i686: W: unused-direct-shlib-dependency /usr/lib/libqaccessibilityclient.so.0.1.0 /lib/libm.so.6
qaccessibilityclient.i686: W: no-manual-page-for-binary accessibleapps
2 packages and 0 specfiles checked; 0 errors, 12 warnings.
# echo 'rpmlint-done:'



Requires
--------
qaccessibilityclient-devel (rpmlib, GLIBC filtered):
    libqaccessibilityclient.so.0
    qaccessibilityclient(x86-32)

qaccessibilityclient (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    libQtCore.so.4
    libQtDBus.so.4
    libQtGui.so.4
    libQtTest.so.4
    libc.so.6
    libgcc_s.so.1
    libgcc_s.so.1(GCC_3.0)
    libm.so.6
    libqaccessibilityclient.so.0
    libstdc++.so.6
    libstdc++.so.6(CXXABI_1.3)
    rtld(GNU_HASH)



Provides
--------
qaccessibilityclient-devel:
    qaccessibilityclient-devel
    qaccessibilityclient-devel(x86-32)

qaccessibilityclient:
    libqaccessibilityclient.so.0
    qaccessibilityclient
    qaccessibilityclient(x86-32)



Generated by fedora-review 0.4.0 (660ce56) last change: 2013-01-29
Buildroot used: fedora-18-i386
Command line :/bin/fedora-review -b 907075 -m fedora-18-i386
(I had to use fedora-18-i386 because Rawhide is currently broken.)


MUST:
* fix the changelog (says 0.1.0-1.20121113git, should say 0.1.0-0.1.20121113git)
* add missing Requires: cmake to -devel
* add missing Requires: qt4-devel to -devel

SHOULD:
* The accessibleapps test does not belong in the main package. Either put it in a subpackage (e.g. -tests or -tools) or don't install it at all.
* Remove the bogus rm -fv cmake/FindOpenCV.cmake
* Change Url: to URL:
* change %define to %global
* libqaccessibilityclient needs to link libQtGui:
-    target_link_libraries(qaccessibilityclient ${QT_QTCORE_LIBRARY} ${QT_QTDBUS_LIBRARY})
+    target_link_libraries(qaccessibilityclient ${QT_QTCORE_LIBRARY} ${QT_QTGUI_LIBRARY} ${QT_QTDBUS_LIBRARY})
  in src/CMakeLists.txt (the Qt 5 case is correct, the Qt 4 one is broken). Leaving symbols unresolved can cause problems.
Comment 5 Rex Dieter 2013-03-13 22:56:34 EDT
Spec URL: http://rdieter.fedorapeople.org/rpms/simon/qaccessibilityclient.spec
SRPM URL: http://rdieter.fedorapeople.org/rpms/simon/qaccessibilityclient-0.1.0-0.2.20121113git.fc18.src.rpm

%changelog
* Wed Mar 13 2013 Rex Dieter <rdieter@fedoraproject.org> 0.1.0-0.2.20121113git
- fix changelog
- -devel: +Requires: cmake qt4-devel
- link QT_QTGUI_LIBRARY for undefined symbols
- s/Url/URL/
- don't package accessibleapps
Comment 6 Kevin Kofler 2013-03-13 23:48:36 EDT
Looks good now, all MUST issues and most SHOULD issues addressed (only the %define is left, why not use %global?).

APPROVED
Comment 7 Rex Dieter 2013-03-14 11:07:29 EDT
New Package SCM Request
=======================
Package Name: qaccessibilityclient
Short Description: Accessibility client library for Qt
Owners: than rdieter jreznik kkofler ltinkl rnovacek
Branches: f17 f18 f19
InitialCC:
Comment 8 Gwyn Ciesla 2013-03-14 11:49:39 EDT
Git done (by process-git-requests).
Comment 9 Rex Dieter 2013-03-14 23:02:43 EDT
imported.

Note You need to log in before you can comment on or make changes to this bug.